var variantOptions = [];
var selectedVariants = [];

$(document).ready(function() {
	//Sort out the bootstrap column classes on certain elements
	//Currency inputs and labels
	var currencyInputs = $('input[data-type=currency]');
	currencyInputs.parent().removeClass('col-md-9 col-sm-10');
	currencyInputs.parent().addClass('col-md-6 col-sm-6');

	currencyInputs.parent().prev().removeClass('col-md-3 col-sm-2');
	currencyInputs.parent().prev().addClass('col-md-6 col-sm-6');

	//stock options
	var multiChecks = $('.form-group-multicheck');
	multiChecks.parent().removeClass('col-sm-9');
	multiChecks.parent().prev().removeClass('col-sm-3');
	multiChecks.parent().prev().addClass('col-md-12');

	// Bulk-pricing updater

	// Loop through all the variant records and get an array of their options

	$('fieldset.variant-record').each(function(e) {
		var optionList = $(this).attr('data-options').split(',');
		variantOptions[$(this).attr('data-variant')] = optionList;
	});

	$('input[type=checkbox].variant-option-selector').on('change', function() {
		selectedVariants = [];
		rebuildSelectedVariants();
	});

	$('.variant-modal-save').on('click', function() {
		updateSelectedVariants();
		resetVariantModal();

		$('#optionsModal').find('.modal-loading').fadeIn('fastest').delay(1000, function() {
			$(this).closest('#optionsModal').modal('hide').find('.modal-loading').fadeOut('fastest');
			// USE BS EVENT TO DETECT CLOSE AND THEN HIDE THE LOADING BIT
		});


	});

	// Virtual tax field generation
	$('input[data-type=currency]').each(function(e) {
		if ($(this).attr('data-taxrate') > 0 && $(this).attr('data-field') != 'trade_price') {

			var thisInput = $(this);
			var inputParent = thisInput.parent();

			var cloned = inputParent.clone();
			cloned.addClass('taxed');

			//label isn't part of cloned so it has to be cloned seperately
			// cloned.closest('label').html($(this)..parent().closest('label').html() + ' (inc. Tax)');
			cloned.find('input').attr('data-type', 'currency-taxed');
			cloned.find('input').attr('name', 'taxed_' + $(this).attr('name'));
			cloned.find('.display-info').remove();

			newCloned = inputParent.after(cloned);

			//label isn't part of cloned so it has to be cloned seperately
			clonedLabel = inputParent.prev().clone();

			if (cloned.find('input').attr('data-taxlabel') == true) {
				clonedLabel.html('inc. VAT');
			} else {
				clonedLabel.html('inc. Tax');
			}


			$(newCloned).after(clonedLabel);

			if ($(this).val() > 0) {
				cloned.find('input').val(calculateTax($(this)));
			}

			$(this).on('change keyup', function() {
				cloned.find('input').val(calculateTax($(this)));
			});

			cloned.find('input').on('change keyup', function() {
				thisInput.val(calculateReverseTax(cloned.find('input')));
			});
		}
	});
});


function calculateTax(input) {
	var taxRate = '1.' + parseInt(input.attr('data-taxrate'));
	var value = input.val();
	var taxedValue = value * taxRate;
	taxedValue = (Math.round(taxedValue * 100) / 100).toFixed(2);

	return taxedValue;
}

function calculateReverseTax(input) {
	var taxRate = '1.' + parseInt(input.attr('data-taxrate'));
	var value = input.val();
	var untaxedValue = (value / taxRate).toFixed(3);

	if (untaxedValue.toString()[untaxedValue.length - 1] == 0) {
		untaxedValue = parseFloat(untaxedValue).toFixed(2);
	} else {
		untaxedValue = parseFloat(untaxedValue)
	}

	return untaxedValue;

}

function rebuildSelectedVariants() {

	var selectedOptions = [];
	selectedVariants = [];

	$('input[type=checkbox].variant-option-selector').each(function() {
		if ($(this).prop('checked')) {
			selectedOptions.push($(this).attr('data-option'));
		}
	});
	// Recalculate selected variants
	$('fieldset.variant-record').each(function(e) {
		var optionList = $(this).attr('data-options').split(',');
		var selectedItems = [];
		for(var i = 0; i<= optionList.length; i++) {
			var option = optionList[i];

			if (option != undefined && option > 0) {
				if (option > 0 && jQuery.inArray(option, selectedOptions) !== -1) {
					console.log(option + ' is in array');
					console.log(selectedOptions);
					selectedItems.push(option);
				}
			}
		}

		if(selectedItems.length == selectedOptions.length && jQuery.inArray($(this).attr('data-variant'), selectedVariants) == -1) {
			selectedVariants.push($(this).attr('data-variant'));
		} else {
			selectedVariants = jQuery.grep(selectedVariants, function (value) {
				return value != $(this).attr('data-variant');
			})
		}
	});

	if(selectedOptions.length <= 0) {
		selectedVariants = [];
	}

	// update total display
	$('.totalApplicableVariants').parent().fadeOut(150).fadeIn(150).fadeOut(150).fadeIn(150);
	$('.totalApplicableVariants').html(selectedVariants.length);
}

function updateSelectedVariants() {

	// get a master list of the bulk-update values to use
	var rrpList = [];
	var priceList = [];
	var salePriceList = [];
	var tradePriceList = [];

	$('#optionsModal').find('input[data-type=currency]').each(function() {
		if ($(this).attr('data-field') == 'rrp') {
			rrpList[$(this).attr('data-currency')] = $(this).val();
		} else if ($(this).attr('data-field') == 'price') {
			priceList[$(this).attr('data-currency')] = $(this).val();
		} else if ($(this).attr('data-field') == 'sale_price') {
			salePriceList[$(this).attr('data-currency')] = $(this).val();
		} else if ($(this).attr('data-field') == 'trade_price') {
			tradePriceList[$(this).attr('data-currency')] = $(this).val();
		}
	});

	$('fieldset.variant-record').each(function(e) {

		var variantId = $(this).attr('data-variant');

		if(jQuery.inArray(variantId, selectedVariants) !== -1) {

			$(this).find('input[data-type=currency]').each(function() {
				if ($(this).attr('data-field') == 'rrp') {
					$(this).val(rrpList[$(this).attr('data-currency')]);
				} else if ($(this).attr('data-field') == 'price') {
					$(this).val(priceList[$(this).attr('data-currency')]);
				} else if ($(this).attr('data-field') == 'sale_price') {
					$(this).val(salePriceList[$(this).attr('data-currency')]);
				} else if ($(this).attr('data-field') == 'trade_price') {
					$(this).val(tradePriceList[$(this).attr('data-currency')]);
				}
			});
		}
	});
}

function resetVariantModal() {

	$('#optionsModal').find('input[type=checkbox]').prop('checked', false);
	$('#optionsModal').find('input[data-type=currency]').val(null);

}
